=== src/regress/lib/libc/ldexp/Makefile ===
#	$OpenBSD: Makefile,v 1.1 2017/10/15 12:15:30 visa Exp $

PROG=ldexp_test

.include <bsd.regress.mk>
