=== src/regress/lib/libc/modf/Makefile ===
PROG=modf_test

.include <bsd.regress.mk>
