=== src/regress/lib/libc/sigthr/Makefile ===
#	$OpenBSD: Makefile,v 1.1 2015/10/22 05:30:18 guenther Exp $

PROG=sigthr_test

.include <bsd.regress.mk>
